<?php
/**
* This file contains the non-presentation processing for the Admin section of RSGallery.
* @version $Id$
* @package RSGallery2
* @copyright (C) 2003 - 2006 RSGallery2
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* RSGallery is Free Software
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// add link to css
?>
<link href="<?php echo $mosConfig_live_site; ?>/administrator/components/com_rsgallery2/admin.rsgallery2.css" rel="stylesheet" type="text/css" />
<?php

// initialize the rsg config file
require_once($mosConfig_absolute_path.'/administrator/components/com_rsgallery2/includes/config.class.php');
$rsgConfig = new rsgConfig();
$rsgConfig->loadConfig();

//Load overlib routine for Tooltips
mosCommonHTML::loadOverlib();

//Check for language files, if not found, default to english
if (file_exists($mosConfig_absolute_path.'/administrator/components/com_rsgallery2/language/'.$mosConfig_lang.'.php')){
    include_once($mosConfig_absolute_path.'/administrator/components/com_rsgallery2/language/'.$mosConfig_lang.'.php');
} else {
    include_once($mosConfig_absolute_path.'/administrator/components/com_rsgallery2/language/english.php');
}

// contains misc. utility functions
require_once($mosConfig_absolute_path.'/administrator/components/com_rsgallery2/config.rsgallery2.php');
require_once($mosConfig_absolute_path.'/administrator/components/com_rsgallery2/includes/version.rsgallery2.php');
$rsgVersion = new rsgalleryVersion();

// report all errors if in debug mode
if($rsgConfig->get('debug'))
    error_reporting(E_ALL);

require_once( $mainframe->getPath( 'admin_html' ) );

global $opt, $catid, $uploadStep, $numberOfUploads, $e_id ;
$opt                = mosGetParam( $_REQUEST, 'opt', '' );
$catid              = mosGetParam( $_REQUEST, 'catid', 0 );
$uploadStep         = mosGetParam( $_REQUEST, 'uploadStep', 0 );
$numberOfUploads    = mosGetParam( $_REQUEST, 'numberOfUploads', 1 );
$e_id               = mosGetParam( $_REQUEST, 'e_id', 1 );

$cid    = mosGetParam( $_REQUEST, 'cid', array(0) );
$id     = mosGetParam( $_REQUEST, 'id', 0 );

$rsgOption = mosGetParam( $_REQUEST, 'rsgOption', '' );

$rsgOptions_path = $mosConfig_absolute_path.'/administrator/components/com_rsgallery2/options/';
$rsgClasses_path = $mosConfig_absolute_path.'/administrator/components/com_rsgallery2/includes/';

/**
    this is the new $rsgOption switch.  each option will have a switch for $task within it.
**/
switch( $rsgOption ){
    case 'galleries':
        require_once( $rsgOptions_path . 'galleries.php' );
    break;
}

/**
    admin pathway hack when $rsgOption is used.
    this probably only works with Joomla <1.5
**/
if( $rsgOption != '' ){
    $option = "<a href='$mosConfig_live_site"
        . "/administrator/index2.php?option=com_rsgallery2'>"
        . "RSGallery2</a> / ";
    if( $task == '' ){
        $option .= "$rsgOption";
    }
    else{
        $option .= "<a href='$mosConfig_live_site"
        . "/administrator/index2.php?option=com_rsgallery2&rsgOption=$rsgOption'>"
        . "$rsgOption</a>";
    }
}

// only use the legacy task switch if rsgOption is not used.
if( $rsgOption == '' )
switch ($task){
//     settings/config tasks
    case 'applyConfig':
        HTML_RSGallery::RSGalleryHeader('config', 'Configuration');
        saveConfig();
        showConfig($option, $mosConfig_absolute_path);
        HTML_RSGallery::RSGalleryFooter();
        break;
    case 'saveConfig':
        HTML_RSGallery::RSGalleryHeader('cpanel', 'Control Panel');
        saveConfig();
        HTML_RSGallery::showCP();
        HTML_RSGallery::RSGalleryFooter();
        break;
    case "showConfig":
        HTML_RSGallery::RSGalleryHeader('config', 'Configuration');
        showConfig($option, $mosConfig_absolute_path);
        HTML_RSGallery::RSGalleryFooter();
        break;

//     image tasks
    case "edit_image":
        HTML_RSGallery::RSGalleryHeader('edit', 'Edit');
        editImage($option, $cid[0]);
        HTML_RSGallery::RSGalleryFooter();
        break;
    case "upload":
        HTML_RSGallery::RSGalleryHeader('browser', 'Upload');
        showUpload();
        HTML_RSGallery::RSGalleryFooter();
        break;
    case "batchupload":
        HTML_RSGallery::RSGalleryHeader('', 'Upload ZIP-file');
        batch_upload($option, $task);
        HTML_RSGallery::RSGalleryFooter();
        break;
    case "save_batchupload":
        save_batchupload();
        break;
    case "view_images":
        HTML_RSGallery::RSGalleryHeader();
        viewImages($option);
        HTML_RSGallery::RSGalleryFooter();
        break;
    case "save_image":
        saveImage($option, $id);
        break;
    case "move_image":
        moveImage($option, $cid);
        break;
    case "delete_image":
        HTML_RSGallery::RSGalleryHeader();
        deleteImage( $cid, $option );
        viewImages($option);
        HTML_RSGallery::RSGalleryFooter();
        break;


//     image and category tasks
    case "categories_orderup":
    case "images_orderup":
        orderRSGallery( $cid[0], -1, $option, $task );
        break;
    case "categories_orderdown":
    case "images_orderdown":
        orderRSGallery( $cid[0], 1, $option, $task );
        break;

//     special/debug tasks
    case 'purgeEverything':
        HTML_RSGallery::RSGalleryHeader('cpanel', 'Control Panel');
        purgeEverything();
        HTML_RSGallery::showCP();
        HTML_RSGallery::RSGalleryFooter();
        break;
    case 'reallyUninstall':
        HTML_RSGallery::RSGalleryHeader('cpanel', 'Control Panel');
        reallyUninstall();
        HTML_RSGallery::showCP();
        HTML_RSGallery::RSGalleryFooter();
        break;
/**    case "migration":
        HTML_RSGallery::RSGalleryHeader('dbrestore', 'Migration options');
        showMigration();
        HTML_RSGallery::RSGalleryFooter();
        break;*/
    case "install":
        HTML_RSGallery::RSGalleryHeader('install', 'install');
        RSInstall();
        HTML_RSGallery::RSGalleryFooter();
        break;
    case "regen_thumbs":
        HTML_RSGallery::RSGalleryHeader();
        HTML_RSGALLERY::printAdminMsg( "Feature not implemented. To follow.\n\n\nRonald Smit", true );
        HTML_RSGallery::RSGalleryFooter();
        break;
    case "consolidate_db":
        HTML_RSGallery::RSGalleryHeader('dbrestore','Consolidate Database');
        consolidateDbInform($option);
        HTML_RSGallery::RSGalleryFooter();
        break;
    case "consolidate_db_go":
        HTML_RSGallery::RSGalleryHeader('dbrestore','Consolidate Database');
        consolidateDbGo($option);
        HTML_RSGallery::RSGalleryFooter();
        break;
    case "import_captions":
        HTML_RSGallery::RSGalleryHeader('generic', 'Import Captions');
        import_captions();
        HTML_RSGallery::RSGalleryFooter();
        break;
    case 'viewChangelog':
        HTML_RSGallery::RSGalleryHeader('viewChangelog', 'Changelog');
        viewChangelog();
        HTML_RSGallery::RSGalleryFooter();
        break;
    case 'config_dumpVars':
        HTML_RSGallery::RSGalleryHeader('viewChangelog', 'Configuration Variables');
        config_dumpVars();
        HTML_RSGallery::RSGalleryFooter();
        break;

    case 'config_rawEdit_apply':
        HTML_RSGallery::RSGalleryHeader('config_rawEdit', 'Configuration Raw Edit');
        config_rawEdit_save();
        config_rawEdit( );
        HTML_RSGallery::RSGalleryFooter();
        break;
    case 'config_rawEdit_save':
        HTML_RSGallery::RSGalleryHeader('cpanel', 'Control Panel');
        config_rawEdit_save();
        HTML_RSGallery::showCP();
        HTML_RSGallery::RSGalleryFooter();
        break;
    case 'config_rawEdit':
        HTML_RSGallery::RSGalleryHeader('config_rawEdit', 'Configuration Raw Edit');
        config_rawEdit( );
        HTML_RSGallery::RSGalleryFooter();
        break;
    case 'c_delete':
        HTML_RSGallery::RSGalleryHeader('dbrestore','Consolidate Database');
        c_delete($id);
        consolidateDbGo($option);
        HTML_RSGallery::RSGalleryFooter();
        break;
    case 'c_create':
        HTML_RSGallery::RSGalleryHeader('dbrestore','Consolidate Database');
        c_create($id);
        HTML_RSGALLERY::printAdminMsg('Missing images created');
        consolidateDbGo($option);
        HTML_RSGallery::RSGalleryFooter();
        break;
//     default - the control panel
    case "controlPanel":
    default:
        HTML_RSGallery::RSGalleryHeader('cpanel', 'Control Panel');
        HTML_RSGallery::showCP();
        HTML_RSGallery::RSGalleryFooter();
        break;
}

/**
    raw configuration editor save, debug only
**/
function config_rawEdit_save(){ 
    global $rsgConfig, $mosConfig_absolute_path;
    $rsg_path = $mosConfig_absolute_path. '/administrator/components/com_rsgallery2/'; 
        
    $rsgConfig = new rsgConfig();
    $rsgConfig->loadConfig(); 
    
    if($rsgConfig->saveConfig($_REQUEST)){
        HTML_RSGALLERY::printAdminMsg('Configuration Saved');
        
        //save succesfully,try creating some image directories if we were ask  to
        if(mosGetParam($_REQUEST,'createImdDirs'))
            HTML_RSGALLERY::printAdminMsg('Creating Image directories not Implemented yet.',true);
        }
    else{
        HTML_RSGALLERY::printAdmMsg('Error Saving Configuration');
    }
}

function config_rawEdit( $save=false ){
    if( $save ){
        // save
    }

    HTML_RSGALLERY::config_rawEdit();
}

function viewChangelog(){
    global $mosConfig_absolute_path;
    
    echo '<pre style="text-align: left;">';
    readfile( $mosConfig_absolute_path . '/administrator/components/com_rsgallery2/changelog.php' );
    echo '</pre>';
}

function config_dumpVars(){
    global $rsgConfig;

    $vars = get_object_vars( $rsgConfig );

    echo '<pre style="text-align: left;">';
    print_r( $rsgConfig );
    echo '</pre>';
}

/**
 * This function is called during step 2 of the RSGallery installation. It
 * outputs the HTML allowing the user to select between a "fresh" install,
 * or an "upgrade" install.
 */
function RSInstall()
    {
    global $opt, $mosConfig_live_site, $mosConfig_absolute_path;
    require_once($mosConfig_absolute_path.'/administrator/components/com_rsgallery2/includes/install.class.php');
    $rsgInstall = new rsgInstall();

    if (isset($_REQUEST['type']))
        $type = mosGetParam ( $_REQUEST, 'type'  , '');
    else
        $type = NULL;

    switch ($opt)
        {
        case "fresh":
            $rsgInstall->FreshInstall();
            break;
        case "upgrade":
            $rsgInstall->upgradeInstall();
            break;
        case "migration":
            if( $type=='' ) $rsgInstall->showMigrationOptions();
            else{
                $result = $rsgInstall->doMigration( $type );
                if( $result !==true ){
                    echo $result;
                    HTML_RSGallery::showCP();
                }
                else{
                    echo "migration successful";
                    HTML_RSGallery::showCP();
                }
            }
            break;
        default:
            $rsgInstall->showInstallOptions();
            break;
        }
    }

/**
 * deletes all pictures, thumbs and their database entries. It leaves category information in DB intact.
 * this is a quick n dirty function for development, it shouldn't be available for regular users.
 */
function purgeEverything(){
    global $mosConfig_absolute_path, $rsgConfig;
    
    $fullPath_thumb = $mosConfig_absolute_path . $rsgConfig->get('imgPath_thumb') . '/';
    $fullPath_display = $mosConfig_absolute_path . $rsgConfig->get('imgPath_display') . '/';
    $fullPath_original = $mosConfig_absolute_path . $rsgConfig->get('imgPath_original') . '/';

    processAdminSqlQueryVerbosely( 'DELETE FROM #__rsgallery2_files', 'purged image entries from database.' );
    processAdminSqlQueryVerbosely( 'DELETE FROM #__rsgallery2_galleries', 'purged galleries from database.' );
    processAdminSqlQueryVerbosely( 'DELETE FROM #__rsgallery2_config', 'purged config from database.' );
    processAdminSqlQueryVerbosely( 'DELETE FROM #__rsgallery2_comments', 'purged comments from database.' );

    // remove thumbnails
    HTML_RSGALLERY::printAdminMsg( 'removing thumb images.' );
    foreach ( glob( $fullPath_thumb.'*' ) as $filename ) {
        if( is_file( $filename )) unlink( $filename );
    }
    
    // remove display imgs
    HTML_RSGALLERY::printAdminMsg( 'removing display images.' );
    foreach ( glob( $fullPath_display.'*' ) as $filename ) {
        if( is_file( $filename )) unlink( $filename );
    }
    
    // remove display imgs
    HTML_RSGALLERY::printAdminMsg( 'removing original images.' );
    foreach ( glob( $fullPath_original.'*' ) as $filename ) {
        if( is_file( $filename )) unlink( $filename );
    }
    
    HTML_RSGALLERY::printAdminMsg( 'purged.', true );
}

/**
    drops all RSG2 tables, deletes image directory structure
    use before uninstalling to REALLY uninstall

    TODO: this is a quick hack.  make it work on all OS and with non default directories.
**/
function reallyUninstall(){
    global $mosConfig_absolute_path;
    
    passthru( "rm -r $mosConfig_absolute_path/images/rsgallery");
    HTML_RSGALLERY::printAdminMsg( "Used rm -r to attempt to remove $mosConfig_absolute_path/images/rsgallery" );

    processAdminSqlQueryVerbosely( 'DROP TABLE IF EXISTS #__rsgallery2_files', 'DROPed #__rsgallery2_files' );
    processAdminSqlQueryVerbosely( 'DROP TABLE IF EXISTS #__rsgallery2_galleries', 'DROPed #__rsgallery2_galleries' );
    processAdminSqlQueryVerbosely( 'DROP TABLE IF EXISTS #__rsgallery2_config', 'DROPed #__rsgallery2_config' );
    processAdminSqlQueryVerbosely( 'DROP TABLE IF EXISTS #__rsgallery2_comments', 'DROPed #__rsgallery2_comments' );

    HTML_RSGALLERY::printAdminMsg( "Done.  Manually remove anything above if there is an error.  You should uninstall RSGallery2 right NOW or you will recieve errors." );
}

/**
    runs a sql query, displays admin message on success or error on error
    @param String sql query
    @param String message to display on success
    @return boolean value indicating success
**/
function processAdminSqlQueryVerbosely( $query, $successMsg ){
    global $database;
    
    $database->setQuery( $query );
    $database->query();
    if($database->getErrorMsg()){
            HTML_RSGALLERY::printAdminMsg( $database->getErrorMsg(), true );
            return false;
    }
    else{
        HTML_RSGALLERY::printAdminMsg( $successMsg );
        return true;
    }
}

function deleteImage( $cid, $option ){
    foreach ($cid as $id){
        imgUtils::deleteImage( galleryUtils::getFileNameFromId( $id ));
    }
    
    HTML_RSGALLERY::printAdminMsg( _RSGALLERY_ALERT_IMGDELETEOK );
}

function c_delete($id) {
global $database;
    $cid    = mosGetParam($_REQUEST, 'cid', '');
    
    $sql = "DELETE FROM #__rsgallery2_files WHERE id = '$cid'";
    $database->setQuery($sql);
    if($database->query())
        {
        HTML_RSGALLERY::printAdminMsg( _RSGALLERY_ALERT_IMGDELETEOK );
        }
    else
        {
        HTML_RSGALLERY::printAdminMsg( _RSGALLERY_ALERT_IMGDELETENOTOK );
        }
}

function c_create() {
global $rsgConfig, $database, $mosConfig_absolute_path;
$id    = mosGetParam($_REQUEST, 'id', '');
if (!$id)
    {
    $name  = mosGetParam($_REQUEST, 'name', '');
    }
else
    {
    $sql = "SELECT name FROM #__rsgallery2_files WHERE id = '$id'";
    $database->setQuery($sql);
    $name = $database->loadResult();
    }
//Just for readability of code
$original = $mosConfig_absolute_path.$rsgConfig->get('imgPath_original')."/".$name;
$display  = $mosConfig_absolute_path.$rsgConfig->get('imgPath_display')."/".imgUtils::getImgNameDisplay($name);
$thumb    = $mosConfig_absolute_path.$rsgConfig->get('imgPath_thumb')."/".imgUtils::getImgNameThumb($name);
    
if ( file_exists($original) )
    {
    //echo "Original exists --> ";
    //Check if display image exists, if not make it.
    if (!file_exists($display))
        {
        //echo "Display does NOT exist --> ";
        imgUtils::makeDisplayImage($original);
        }
    if (!file_exists($thumb))
        {
        //echo "Thumb does NOT exist -->";
        imgUtils::makeThumbImage($original);
        }
    }
else
    {
    //echo "Original does NOT exist -->";
    if (file_exists($display))
        {
        copy($display, $original);
        }
    if (!file_exists($thumb))
        {
        imgUtils::makeThumbImage($display);
        }
    }
}

function save_batchupload()
    {
    global $database, $mosConfig_absolute_path, $mosConfig_live_site, $rsgConfig;
    
    //Try to bypass max_execution_time as set in php.ini
    set_time_limit(0);
    
    require_once($mosConfig_absolute_path.'/administrator/components/com_rsgallery2/includes/img.utils.php');
    $FTP_path = $rsgConfig->get('ftp_path');

    if (isset($_REQUEST['teller']))     $teller = mosGetParam ( $_REQUEST, 'teller'  , '');
    if (isset($_REQUEST['delete']))     $delete = mosGetParam ( $_REQUEST, 'delete'  , '');
    if (isset($_REQUEST['filename']))   $filename = mosGetParam ( $_REQUEST, 'filename'  , '');
    if (isset($_REQUEST['ptitle']))     $ptitle = mosGetParam ( $_REQUEST, 'ptitle'  , '');
    if (isset($_REQUEST['descr']))      $descr = mosGetParam ( $_REQUEST, 'descr'  , array(0));

    //Check if all categories are chosen
    if (isset($_REQUEST['category']))
        $category = mosGetParam ( $_REQUEST, 'category'  , '');
    else
        $category = NULL;

    if (in_array("0",$category))
        {
        ?>
        <script>
                alert("<?php echo _RSGALLERY_ALERT_NOCATSELECTED;?>");
                history.back();
        </script>
        <?php
        }

     for($i=0;$i<$teller;$i++)
        {
        //If image is marked for deletion, delete and continue with next iteration
        if (isset($delete[$i]) AND ($delete[$i] == 'true'))
            {
            //Delete file from server
            unlink($mosConfig_absolute_path."/media/".$filename[$i]);
            continue;
            }
        else
            {
            //Setting variables for importImage()
            $imgTmpName = $mosConfig_absolute_path."/media/".$filename[$i];
            $imgName = $filename[$i];
            $imgCat = $category[$i];
            $imgTitle = $ptitle[$i];
            $imgDesc = $descr[$i];
            
            $e = imgUtils::importImage($imgTmpName, $imgName, $imgCat, $imgTitle, $imgDesc, $isUploadedFile=true);
            //Error Handling
            if ( $e !== true )
                {
                $errors[] = $e;
                }
            }
            if (isset($errors ))
                {
                if ( count( $errors ) == 0)
                    {
                    echo _RSGALLERY_ALERT_UPLOADOK;
                    }
                else
                    {
                    foreach( $errors as $err )
                        {
                            echo $err->toString();
                        }
                    }
                }
            else
                {
                //Everything went smoothly, back to Control Panel
                ?>
                <script>
                    alert("<?php echo _RSGALLERY_ALERT_UPLOADOK;?>");
                    location = 'index2.php?option=com_rsgallery2';
                </script>
                <?php
                }
            }
    }

function cancelGallery($option)
    {
    mosRedirect("index2.php?option=$option");
    }

/**
 * This function is called when you select batchupload from the backend. It
 * detects whether you choose ZIP or FTP and acts accordingly.
 * When you choose ZIP it unzips the file you upload to "/media" for further
 * handling, if you choose FTP it reads the files from the directory you uploaded
 * the files to and copies them to "/media".(this dir must be on the local server).
 * @todo Better error trapping
 * @todo Check FTP handling bit
 */
 
function batch_upload($option) {
    global $database, $mosConfig_absolute_path,$mosConfig_live_site, $rsgConfig;
    $FTP_path = $rsgConfig->get('ftp_path');

    //Retrieve data from submit form
    if (isset($_REQUEST['batchmethod']))    $batchmethod = mosGetParam ( $_REQUEST, 'batchmethod'  , '');
    if (isset($_REQUEST['uploaded']))         $uploaded = mosGetParam ( $_REQUEST, 'uploaded'  , '');
    if (isset($_REQUEST['selcat']))         $selcat = mosGetParam ( $_REQUEST, 'selcat'  , '');
    if (isset($_FILES['zip_file']))         $zip_file = mosGetParam ( $_FILES, 'zip_file'  , '');
    if (isset($_REQUEST['ftppath']))        $ftppath = mosGetParam ( $_REQUEST, 'ftppath'  , '');
    if (isset($_REQUEST['xcat']))           $xcat = mosGetParam ( $_REQUEST, 'xcat'  , '');
    
    $database->setQuery( "SELECT id FROM #__rsgallery2_galleries" );
    $database->query();
    if( $database->getNumRows()==0 ){
        HTML_RSGALLERY::requestCatCreation( );
        return;
    }
    
    //New instance of fileHandler
    $uploadfile = new fileHandler();
    
    if (isset($uploaded))
        {
        if ($batchmethod == "zip")
            {
            if ($uploadfile->checkSize($zip_file) == 0)
                {
                $ziplist = $uploadfile->handleZIP($zip_file);
                }
            else
                {
                //Error message
                echo "File is too big!";
                }
            }
        else
            {
            $ziplist = $uploadfile->handleFTP($ftppath);
            }
        //show all thumbs on a page with details
        HTML_RSGALLERY::batch_upload_2($ziplist);
        }
    else
        {
        HTML_RSGALLERY::batch_upload($option);
        }
    }//End function
    
    
/** DEPRECATED New one just above, utilizing new fileHandler Class in img.utils.php
  * Need to remove this as soon as the class is working.
  */
function batch_uploadX($option)
    {
    function myPreExtractCallBack($p_event, &$p_header)
        {
        if ($p_header['folder'] == 1)
            {
            return 0;
            }
        else
            {
            return 1;
            }
        }
    global $database, $mosConfig_absolute_path,$mosConfig_live_site, $zip_file, $ziplist, $batchmethod, $rsgConfig;
    include($mosConfig_absolute_path.'/administrator/includes/pcl/pclzip.lib.php');
    $FTP_path = $rsgConfig->get('ftp_path');
    
    //Retrieve data from submit form
    if (isset($_REQUEST['batchmethod']))    $batchmethod = mosGetParam ( $_REQUEST, 'batchmethod'  , '');
    if (isset($_REQUEST['submit']))         $submit = mosGetParam ( $_REQUEST, 'submit'  , '');
    if (isset($_REQUEST['selcat']))         $selcat = mosGetParam ( $_REQUEST, 'selcat'  , '');
    if (isset($_FILES['zip_file']))         $zip_file = mosGetParam ( $_FILES, 'zip_file'  , '');
    if (isset($_REQUEST['ftppath']))        $ftppath = mosGetParam ( $_REQUEST, 'ftppath'  , '');
    if (isset($_REQUEST['xcat']))           $xcat = mosGetParam ( $_REQUEST, 'xcat'  , '');
    
    if (isset($submit))
        {
        if ($batchmethod == "zip")
            {
            //Check if file does not exceed upload_max_filesize in php.ini
            $max_size =ini_get('upload_max_filesize');
            $real_size = $zip_file['size'];
            if ($real_size == 0)
                {
                ?>
                <script>
                    alert("<?php echo _RSGALLERY_BATCH_ERROR_SIZE.$max_size;?>.");
                    location = 'index2.php?option=com_rsgallery2&task=batchupload';
                </script>
                <?php
                }
            //New zipfile
            $zipfile = new PclZip($zip_file['tmp_name']);
            
            //Unzip to ftp directory, removing all path info
            $ziplist = $zipfile->extract(  PCLZIP_OPT_PATH, $mosConfig_absolute_path."/media/",
                                    PCLZIP_OPT_REMOVE_ALL_PATH,
                                    PCLZIP_CB_PRE_EXTRACT, "myPreExtractCallBack",
                                    PCLZIP_OPT_BY_PREG, '/^[^_]/' );
            if ($ziplist == 0){
                die ("- Error message :".$zipfile->errorInfo(true));
            }
        }
        else
            {
            
            //Handle FTP-upload
            if ($handle = @opendir( $ftppath ))
                {
                while (false !== ($file = readdir($handle)))
                    {
                    if ($file != "." && $file != "..")
                        {
                        //Check of upload directory exists and if it exists are there any files to process
                        if (isAllowedFileType($file, "jpg, png, gif"))
                            {
                            //Add filename to array $ziplist
                            $ziplist[]['filename'] = $file;
                            if ($ftppath != "/media/")
                                {
                                //copy to "/media" and unlink file from original location
                                if (copy( $ftppath . $file, $mosConfig_absolute_path."/media/".$file)){
                                    unlink($ftppath.$file);
                                }
                                else
                                    {
                                    //error message
                                    }
                                }
                            else
                                {
                                //Image already in the right place, continue
                                continue;
                                }
                            }
                        else
                            {
                            //unlink file from original location, but leave index.html and Helvetica.afm alone
                            if ($file != "index.html" AND $file != "Helvetica.afm"){
                                echo "<strong>$file</strong> is not an allowed filetype, it will be deleted!!!!<br>";
                                unlink($ftppath.$file);
                            }
                        }
                    }
                }
                closedir($handle);
                }
            else
                {
                ?>
                <script>
                    alert("<?php echo _RSGALLERY_BATCH_ERROR_FTP1;?>");
                    location = 'index2.php?option=com_rsgallery2&task=batchupload';
                </script>
                <?php
                }
            }
        //show all thumbs on a page with details
        HTML_RSGALLERY::batch_upload_2($ziplist);
        }
    else
        {
        HTML_RSGALLERY::batch_upload($option);
        }
    }


function editImage($option, $cid){
    global $e_id, $descr, $xtitle, $submit, $database, $id, $imagepath, $task, $mosConfig_absolute_path;
    if ( $cid[0] != "" ){
        $e_id = $cid[0];
    }
    $database->setQuery("SELECT a.name as fname, title, descr FROM #__rsgallery2_files AS a, #__rsgallery2_galleries AS b WHERE a.gallery_id = b.id AND a.id='$e_id'");
    $rows = $database->loadObjectList();
    HTML_RSGALLERY::editImage($option, $e_id, $rows);
}


// dmcd Feb 05/04  new move image function, to move images to a different category
function moveImage($option, $cid)
    {

    global $database, $mainframe;
    $catmoveid = $mainframe->getUserStateFromRequest( "catmoveid{$option}", 'catmoveid', 0 );

    // there will be at least 1 image selected for a move as well as a valid
    // move category, but check anyways
    $database->setQuery("SELECT id FROM #__rsgallery2_galleries WHERE id = '$catmoveid'");

    if ($cid && $catmoveid && $database->loadResult()){
        // get largest ordering num from target category
        $database->setQuery("SELECT MAX(ordering) FROM #__rsgallery2_files WHERE gallery_id = '$catmoveid'");
        $k=$database->loadResult()+1;
        for($i=0;$i<count($cid);$i++){
            $e_id = $cid[$i];
            $database->setQuery("UPDATE #__rsgallery2_files SET ordering = $k, gallery_id = '$catmoveid' WHERE id='$e_id'");
            $database->query();
            $k++;
        }
    viewImages($option);
   }
}


function ftp_upload() {
global $database, $mosConfig_absolute_path, $mosConfig_live_site, $submit, $rsgConfig;
$FTP_path = $rsgConfig->get('ftp_path');
$allowed_ext = array("gif","jpg","png");
    
if (isset($_REQUEST['submit'])) $submit = mosGetParam ( $_REQUEST, 'submit'  , '');

    if ($submit) {
        if( $handle = opendir( $FTP_path ) )
            {
            while (false !== ($file = readdir($handle)))
                {
                if ($file != "." && $file != "..")
                    {
                    if( copy( $FTP_path.$file, "$mosConfig_absolute_path/media/$file" ) )
                        {
                        chmod($mosConfig_absolute_path."/media/".$file,0755);
                            // make sure file is an image and process it
                            $frag = array_reverse(explode(".", $file));
                            $ext = strtolower($frag[0]);
    
                            if( in_array( $ext, $allowed_ext ) )
                            {
                                $ziplist[]['filename'] = $file;
                                unlink( $FTP_path.$file );
                            }
                        }
                    }
                }
            closedir($handle);
            }
            //show all thumbs on a page with details
            HTML_RSGALLERY::batch_upload_2($ziplist, $mosConfig_live_site,$mosConfig_absolute_path);
        } else {
        HTML_RSGALLERY::ftp_upload();
    }
}


/**
* single file (at a time) upload function
*/
function showUpload(){
    global $catid, $database, $uploadStep, $mosConfig_absolute_path, $rsgConfig;

    require_once($mosConfig_absolute_path.'/administrator/components/com_rsgallery2/includes/img.utils.php');
    if (isset($_REQUEST['uploadstep'])) $uploadstep = mosGetParam ( $_REQUEST, 'uploadstep'  , ''); 


    switch($uploadStep){
        // choose category
        case 0:
        case 1:
            // determine if any galleries exist
            $database->setQuery( "SELECT id FROM #__rsgallery2_galleries" );
            $database->query();

            if( $database->getNumRows()==0 ){
                HTML_RSGALLERY::requestCatCreation( );
                return;
            }

            HTML_RSGALLERY::showUploadStep1( );

            break;

        // choose number of files
        case 2:
            HTML_RSGALLERY::showUploadStep2( );
            break;

        // choose files to upload
        case 3:
            HTML_RSGALLERY::showUploadStep3( );
            break;

        // files uploaded
        case 4:
            if (isset($_REQUEST['imgTitle'])) $imgTitle = mosGetParam ( $_REQUEST, 'imgTitle'  , ''); 
            if (isset($_REQUEST['images'])) $images = mosGetParam ( $_REQUEST, 'images'  , ''); 
            if (isset($_REQUEST['descr'])) $descr = mosGetParam ( $_REQUEST, 'descr'  , ''); 
            if (isset($_REQUEST['catid'])) $catid = mosGetParam ( $_REQUEST, 'catid'  , ''); 
            $errors = array();

            foreach ($_FILES["images"]["error"] as $key => $error) {
                if($error != UPLOAD_ERR_OK){
                    $errors[] = new imageUploadError($_FILES["images"]["name"][$key], $error);
                    continue;
                }

                // check if file was actually uploaded
                if( !is_uploaded_file( $_FILES["images"]["tmp_name"][$key] )) {
                    $errors[] = new imageUploadError( $_FILES["images"]["tmp_name"][$key], "not an uploaded file, potential malice detected!" );
                    continue;
                }

                $e = imgUtils::importImage($_FILES["images"]["tmp_name"][$key], $_FILES["images"]["name"][$key], $catid, $imgTitle[$key], $descr[$key]);

                if ( $e !== true ) $errors[] = $e;
            }

            if ( count( $errors ) == 0){
                echo _RSGALLERY_ALERT_UPLOADOK;
            }
            else{
                foreach( $errors as $e ){
                    echo $e->toString();
                }
                if ( count( $errors ) < count( $_FILES["images"]["error"] ) ){
                    echo "<br>the rest of your files were uploaded fine";
                }
            }
            viewImages(null);
            break;
        default: die("default switch case in function showUpload().  this should never happen.");
    }
}



function saveImage($option, $id)
    {
    //$xtitle = addslashes($xtitle);
    //$descr = addslashes($descr);
    global $database, $descr, $id, $xtitle;
    if (isset($_REQUEST['xtitle'])) $xtitle = mosGetParam ( $_REQUEST, 'xtitle'  , '');
    if (isset($_REQUEST['descr'])) $descr = mosGetParam ( $_REQUEST, 'descr'  , '');
    

    $database->setQuery("UPDATE #__rsgallery2_files SET descr = '$descr', title = '$xtitle' WHERE id='$id'");
    if ($database->query())
        {
        //terug naar overzicht
        ?>
        <script>
            alert("<?php echo _RSGALLERY_ALERT_IMAGEDETAILSOK;?>");
            location = "index2.php?option=com_rsgallery2&task=view_images";
        </script>
        <?php
        }
    else
        {
        ?>
        <script>
            alert("<?php echo _RSGALLERY_ALERT_IMAGEDETAILSNOTOK;?>");
            location = "index2.php?option=com_rsgallery2&task=view_images";
        </script>
        <?php
        }
    }


/**
    TODO: if thumbname size has changed, advise user to regenerate thumbs
**/
function saveConfig(){
    global $rsgConfig,$mosConfig_absolute_path;
    $rsg_path = $mosConfig_absolute_path . '/administrator/components/com_rsgallery2/';

    require_once( $rsg_path . 'includes/config.class.php' );

    $rsgConfig = new rsgConfig();
    $rsgConfig->loadConfig();
    
    if( $rsgConfig->saveConfig( $_REQUEST )){
            HTML_RSGALLERY::printAdminMsg('Configuration Saved');

            // save successful, try creating some image directories if we were asked to
            if( mosGetParam( $_REQUEST, 'createImgDirs' ))
                HTML_RSGALLERY::printAdminMsg('Creating image directories not implemented yet.', true);
            
    }else{
            HTML_RSGALLERY::printAdminMsg('Error Saving Configuration');
    }
}

function showConfig(){
    global $rsgConfig, $mosConfig_absolute_path;
    require_once $mosConfig_absolute_path . '/administrator/components/com_rsgallery2/includes/img.utils.php';
    
    $rsg_path   = $mosConfig_absolute_path . '/administrator/components/com_rsgallery2/';

    $langs      = array();
    $imageLib   = array();
    $lists      = array();

    // PRE-PROCESS SOME LISTS

    // -- Languages --

    if ($handle = opendir( $rsg_path . '/language/' )) {
        $i=0;
        while (false !== ($file = readdir( $handle ))) {
            if (!strcasecmp(substr($file,-4),".php") && $file <> "." && $file <> ".." && strcasecmp(substr($file,-11),".ignore.php")) {
                $langs[] = mosHTML::makeOption( substr($file,0,-4) );
            }
        }
    }

    // sort list of languages
    sort( $langs );
    reset( $langs );

    /**
     * detect available graphics libraries
     * @todo call imgUtils graphics lib detection when it is built
    */
    $graphicsLib = array();

    $result = GD2::detect();
    if( $result )
        $graphicsLib[] = mosHTML::makeOption( 'gd2', $result );
    else
        $graphicsLib[] = mosHTML::makeOption( 'gd2', 'GD2 not detected' );

    $result = ImageMagick::detect();
    if( $result )
        $graphicsLib[] = mosHTML::makeOption( 'imagemagick', $result );
    else
        $graphicsLib[] = mosHTML::makeOption( 'imagemagick', 'ImageMagick not detected' );

    $result = Netpbm::detect();
    if( $result )
        $graphicsLib[] = mosHTML::makeOption( 'netpbm', $result );
    else
        $graphicsLib[] = mosHTML::makeOption( 'netpbm', 'netPBM not detected' );
    
    
    $lists['graphicsLib'] = mosHTML::selectList( $graphicsLib, 'graphicsLib', '', 'value', 'text', $rsgConfig->graphicsLib );

    

    /*
    $conf_style='error: can\'t read css file.';
    if(is_readable($cssfile)){
        $css = fopen($cssfile, 'r');
        $conf_style = fread($css, filesize($cssfile));
        fclose($css);
    }*/

    HTML_RSGALLERY::showconfig( $lists );
}


function viewImages($option)
    {
    //HTML_RSGALLERY::RSGalleryHeader();


    global $option, $database, $mainframe, $xid, $mosConfig_absolute_path;

    $catid = $mainframe->getUserStateFromRequest( "catid{$option}", 'catid', 0 );
    $catChanged = $mainframe->getUserStateFromRequest( "catChanged{$option}", 'catChanged', 0 );
    $limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', 10 );
    $limitstart = $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );
    $search = $mainframe->getUserStateFromRequest( "search{$option}", 'search', '' );
    $search = $database->getEscaped( trim( strtolower( $search ) ) );

    // dmcd mar 6/04  to resolve bug #33 where paging goes wacko after
    // category filter select is changed, we need to detect this select
    // field change and reset limitstart back to 0.  Need a new hidden
    // input called 'catChanged'

    if ($catid > 0)
        {
        $sql = "SELECT count(*) FROM #__rsgallery2_files AS a".
                  "\nWHERE a.gallery_id='$catid'";
        }
    else
        {
        $sql = "SELECT count(*) FROM #__rsgallery2_files AS a";
        }
    //get the total number of records
    $database->setQuery($sql);
    $total = $database->loadResult();
    echo $database->getErrorMsg();

    include_once( $mosConfig_absolute_path."/administrator/includes/pageNavigation.php" );
    if($catChanged) $limitstart=0;
    $pageNav = new mosPageNav( $total, $limitstart, $limit  );
    $where = array();

    if ($catid > 0)
        {

        $sql2 = "SELECT a.name as fname, a.hits as ahits,a.id as xid,a.ordering as fordering, a.*,b.* FROM #__rsgallery2_files as a, #__rsgallery2_galleries as b".
                  "\n WHERE (a.gallery_id = b.id AND b.id = '$catid')".
                  "\n ORDER BY a.ordering".
                  "\n LIMIT $pageNav->limitstart,$pageNav->limit";
        }
    else
        {
        $sql2 = "SELECT a.name as fname, a.hits as ahits,a.id as xid,a.ordering as fordering, a.*,b.* FROM #__rsgallery2_files as a, #__rsgallery2_galleries as b".
                "\n WHERE a.gallery_id = b.id".
                "\n ORDER BY b.ordering, a.ordering".
                "\n LIMIT $pageNav->limitstart,$pageNav->limit";
        }

    $database->setQuery($sql2);
    $rows = $database->loadObjectList();
    if ($database->getErrorNum()) {
        echo $database->stderr();
        return false;
    }

    // get list of categories
    $categories[] = mosHTML::makeOption( '0', 'View Category' );
    $categories[] = mosHTML::makeOption( '-1', '- All Categories' );
    $database->setQuery( "SELECT id AS value, name AS text FROM #__rsgallery2_galleries"
        . "\n ORDER BY name" );
    $dbCategories = $database->loadObjectList();
    $categories = array_merge( $categories, $dbCategories );

    $clist = mosHTML::selectList( $categories, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.catChanged.value=1;document.adminForm.submit();"',
        'value', 'text', $catid );
    $categories[0] = mosHTML::makeOption( '0', 'Select Category' );
    array_splice($categories, 1, 1);
    $clist2 = mosHTML::selectList( $categories, 'catmoveid', 'class="inputbox" size="1" ', 'value', 'text', 0 );

    // dmcd jan 12/04  tally total pics per category/gallery
        $database->setQuery("SELECT id FROM #__rsgallery2_galleries");
        $catss = $database->loadResultArray();
 foreach($catss as $cat){
            $database->setQuery("SELECT MAX(ordering), MIN(ordering) FROM #__rsgallery2_files WHERE gallery_id = '$cat'");
            $maxmin = $database->loadRow();
            $cat_ordering_max[$cat] = $maxmin[0];
            $cat_ordering_min[$cat] = $maxmin[1];
       }
       //asdbg_break();
        HTML_RSGALLERY::viewImages( $option, $rows, $clist, $clist2, $search, $pageNav, $cats, $cat_ordering_min, $cat_ordering_max );
    //HTML_RSGALLERY::RSGalleryFooter();
}


/**
 * This function is used to handle the RSGallery ordering tasks (I.e. the user indicating
 * that they want to display a given image and/or category before or after another one.)
 */
function orderRSGallery( $id, $inc, $option, $task ) {
   global $database;
   // reorder categories or pics within a category
//asdbg_break();

switch ($task){
      case "images_orderup":
      case "images_orderdown":
         $table = "#__rsgallery2_files";
         $where = "gallery_id = '\$row->gallery_id'";
         $new_task = "view_images";
         break;

      default:
         $table = "#__rsgallery2_galleries";
         $where = NULL;
         $new_task = "view_categories";
         break;
   }

   $sql = "SELECT * FROM $table WHERE id = $id";
   $database->setQuery( $sql );
   $database->loadObject($row);

   eval("\$where=\"$where\";");
   $sql = "SELECT id, ordering FROM $table";
   if ($inc < 0) {
      $sql .= "\nWHERE ordering < '$row->ordering'";
      $sql .= ($where ? "\n AND $where" : '');
      $sql .= "\nORDER BY ordering DESC\nLIMIT 1";
   } else if ($inc > 0) {
      $sql .= "\nWHERE ordering > '$row->ordering'";
      $sql .= ($where ? "\n AND $where" : '');
      $sql .= "\nORDER BY ordering\nLIMIT 1";
   } else {
      $sql .= "\nWHERE ordering = '$row->ordering'";
      $sql .= ($where ? "\n AND $where" : '');
      $sql .= "\nORDER BY ordering\nLIMIT 1";
   }

   $database->setQuery( $sql );
   $adj_row = null;
   if ($database->loadObject( $adj_row )) {
      $database->setQuery( "UPDATE $table SET ordering='$row->ordering'"
     . "\nWHERE id='".$adj_row->id."'");
      $database->query();
      $database->setQuery( "UPDATE $table SET ordering='$adj_row->ordering'"
     . "\nWHERE id='".$row->id."'");
      $database->query();
   } else {
      // no adjacent row: either the only row or already the first or last row
      // what is this really doing?
      $database->setQuery( "UPDATE $table SET ordering='$row->ordering'"
     . "\nWHERE id='".$id."'");
      $database->query();
   }

   // go back to RSGallery category or image listing
   mosRedirect( "index2.php?option=$option&task=".$new_task );
}

function consolidateDbInform($option){
    // inform user of purpose of this function, then provide a proceed button
    //HTML_RSGALLERY::RSGalleryHeader();
?>
    <script language="Javascript">
        function submitbutton(pressbutton){
            if (pressbutton != 'cancel'){
                submitform( pressbutton );
                return;
            } else {
                window.history.go(-1);
                return;
            }
        }
    </script>
    <form action="index2.php" method="post" name="adminForm">
    <table class="adminform" cellpadding="4" cellspacing="0" border="0" width="98%" align="center">
        <tr>
            <td>&nbsp;</td>
        </tr>
        <tr>
            <td><?php echo _RSGALLERY_CONSOLIDATE_DB;?></td>
        </tr>
        <tr>
            <td>
                <div align="center">
                <input type="button" name="consolidate_db_go" value="<?php echo _RSGALLERY_PROCEED ?>" class="button" onClick="submitbutton('consolidate_db_go');" />
                <input type="button" name="cancel" value="<?php echo _RSGALLERY_CANCEL ?>" class="button" onClick="submitbutton('cancel');" />
                </div>
            </td>
        </tr>
    </table>
    <input type="hidden" name="option" value="<?php echo $option;?>" />
    <input type="hidden" name="task" value="" />
    </form>

<?php
}
/**
 * Changes all values of an array to lowercase
 * @param array mixed case mixed or upper case values
 * @return array lower case values
 */
function arrayToLower($array) {
    $array = explode("|", strtolower(implode("|",$array)));
    return $array;
}

/**
 * Fills an array with the filenames, found in the specified directory
 * @param string Directory from Joomla root
 * @return array Array with filenames
 */
function getFilenameArray($dir){
    global $mosConfig_absolute_path, $rsgConfig;
    
    //Load all image names from filesystem in array
    $dh  = opendir($mosConfig_absolute_path.$dir);
    //Files to exclude from the check
    $exclude = array('.', '..', 'Thumbs.db', 'thumbs.db');
    $allowed = array('jpg','gif');
    while (false !== ($filename = readdir($dh)))
        {
        $ext = explode(".", $filename);
        $ext = array_reverse($ext);
        $ext = strtolower($ext[0]);
        if (!is_dir($mosConfig_absolute_path.$dir."/".$filename) AND !in_array($filename, $exclude) AND in_array($ext, $allowed))
            {
            if ($dir == $rsgConfig->get('imgPath_display') OR $dir == $rsgConfig->get('imgPath_thumb'))
                {
                //Recreate normal filename, eliminating the extra ".jpg"
                $names_fs[] = substr(strtolower($filename), 0, -4);
                }
            else
                {
                $names_fs[] = strtolower($filename);
                }
            }
        else
            {
            //Do nothing
            continue;
            }
        }
    return $names_fs;
    
}
function consolidateDbGo($option)
    {
    global $database, $rsgConfig, $mosConfig_absolute_path, $mosConfig_live_site;

    //Load all image names from DB in array
    $sql = "SELECT name FROM #__rsgallery2_files";
    $database->setQuery($sql);
    $names_db = arrayToLower($database->loadResultArray());

    $files_display  = getFilenameArray($rsgConfig->get('imgPath_display'));
    $files_original = getFilenameArray($rsgConfig->get('imgPath_original'));
    $files_thumb    = getFilenameArray($rsgConfig->get('imgPath_thumb'));
    $files_total    = array_unique(array_merge($files_display,$files_original,$files_thumb));
    
    HTML_RSGALLERY::consolidateDbGo($names_db, $files_display, $files_original, $files_thumb, $files_total);
    }

function import_captions()
    {
    echo "Feature not yet implemented. To follow.<br><br><br>Ronald Smit";
    }

//--------------------------------------------------------------------------

?>