<?php
/**
* This file handles configuration processing for RSGallery.
*
* @version $Id$
* @package RSGallery2
* @copyright (C) 2003 - 2006 RSGallery2
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* RSGallery is Free Software
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
require_once($mosConfig_absolute_path.'/administrator/components/com_rsgallery2/includes/img.utils.php');
/**
 * simple error class
 * built to make migration to php5 easier (hopefully)
 */
class imageUploadError{
    var $filename;
    var $error;
    
    function ImageUploadError($f, $e){
        $this->filename=$f;
        $this->error=$e;
    }

    function getFilename(){
        return $this->filename;
    }
    
    function getError(){
        return $this->error;
    }
    
    function toString(){
        return " - Error Image Upload : " . $this->filename . " : " . $this->error . "<br>";
    }
}

/**
 * Class with util functions for RSGallery2
 */
class galleryUtils {

    /**
     * shows proper Joomla path
     * contributed by Jeckel
     */
    function showRSPath($catid, $imgid = 0){
        global $mainframe, $database, $mosConfig_live_site, $mosConfig_absolute_path, $Itemid;
    
        if ($catid != 0) {
            $database->setQuery('SELECT * FROM #__rsgallery2_galleries WHERE id = "'. $catid . '"');
            $rows = $database->loadObjectList();

            $cat = $rows[0];
            $cats = array();
            array_push($cats, $cat);
            
            while ($cat->parent != 0) {
                $database->setQuery('SELECT * FROM #__rsgallery2_galleries WHERE id = "' . $cat->parent . '"');
                $rows = $database->loadObjectList();
                $cat = $rows[0];
                array_unshift($cats, $cat);
            }    // while
            
            reset($cats);
            foreach($cats as $cat) {
                if ($cat->id == $catid && empty($imgid)) {
                    $mainframe->appendPathWay($cat->name);
                } else {
                    $mainframe->appendPathWay('<a href="' . $mosConfig_live_site . '/index.php?option=com_rsgallery2&amp;Itemid='.$Itemid.'&amp;catid=' . $cat->id . '">' . $cat->name . '</a>');
                }    // if
            }    // foreach
        }    // if
        
        if (!empty($imgid)) {
            $database->setQuery('SELECT title FROM #__rsgallery2_files WHERE id = "'. $imgid . '"');
            $imgTitle = $database->loadResult();
            $mainframe->appendPathWay($imgTitle);
        }    // if
        
    }

    /**
     * Shows random images for display on main page
     */
    function showRandom() {
    global $database;

    $database->setQuery("SELECT file.gallery_id, file.ordering, file.id, file.name, file.descr".
                        " FROM #__rsgallery2_files file, #__rsgallery2_galleries gal".
                        " WHERE file.gallery_id=gal.id and gal.published=1".
                        " ORDER BY rand() limit 3");
    $rows = $database->loadObjectList();

    HTML_RSGALLERY::showRandom($rows);
    }

    /**
     * Shows latest uploeded images for display on main page
     */
    function showLatest() {
    global $database;
    
    $database->setQuery("SELECT file.gallery_id, file.ordering, file.id, file.name, file.descr".
                        " FROM #__rsgallery2_files file, #__rsgallery2_galleries gal".
                        " WHERE file.gallery_id=gal.id and gal.published=1".
                        " ORDER BY file.date DESC limit 3");
    $rows = $database->loadObjectList();
    
    HTML_RSGALLERY::showLatest($rows);
    }
    
    /**
     * Shows a dropdownlist with all categories, owned by the logged in user
     * @param int Category ID to show the current category selected. Defaults to 0.
     * @param int User ID of the owner of the gallery
     * @param string Name of select form element
     * @return string HTML representation of dropdown box
     * @todo Make all categories visible if user is Super Administrator
     */
    function showCategories($s_id = 0, $uid, $selectname = 'i_cat') {
	global $database, $dropdown_html;
	$database->setQuery("SELECT * FROM #__rsgallery2_galleries WHERE parent = '0' AND uid = '$uid' ORDER BY ordering ASC");
	$rows = $database->loadObjectList();
	$dropdown_html = "<select name=\"$selectname\"><option value=\"xx\" SELECTED>- Select category -</option>\n";

    foreach ($rows as $row)
		{
		$id = $row->id;
		$database->setQuery("SELECT * FROM #__rsgallery2_galleries WHERE parent = '$id' AND uid = '$uid' ORDER BY ordering ASC");
		$rows2 = $database->loadObjectList();

		if (!isset($s_id))
			{
			$s_id=0;
			}
        $dropdown_html .= "<option value=\"$row->id\"";
        if ($row->id == $s_id)
            $dropdown_html .= " SELECTED>";
        else
            $dropdown_html .= ">";
        $dropdown_html .=  $row->name."</option>\n";

		foreach($rows2 as $row2)
			{
            $dropdown_html .= "<option value=\"$row2->id\">-->$row2->name</option>\n";
			}
		}
        echo $dropdown_html."</select>";
	}
    
    /**
     * build the select list to choose a gallery
     * based on options/galleries.class.php:galleryParentSelectList()
     * @param int current gallery id
     * @param string selectbox name
     * @param boolean Dropdown(false) or Liststyle(true)
     * @return string HTML representation for selectlist
     */
    function galleriesSelectList( $galleryid=null, $listName='galleryid', $style = true ) {
    global $database;
    if ($style == true)
        $size = ' size="10"';
    else
        $size = ' size="1"';
    // get a list of the menu items
    // excluding the current menu item and its child elements
    $query = "SELECT *"
    . " FROM #__rsgallery2_galleries"
    . " WHERE published != -2"
    . " ORDER BY parent, ordering"
    ;
    $database->setQuery( $query );
    
    $mitems = $database->loadObjectList();

    // establish the hierarchy of the menu
    $children = array();

    if ( $mitems ) {
        // first pass - collect children
        foreach ( $mitems as $v ) {
            $pt     = $v->parent;
            $list   = @$children[$pt] ? $children[$pt] : array();
            array_push( $list, $v );
            $children[$pt] = $list;
        }
    }

    // second pass - get an indent list of the items
    $list = mosTreeRecurse( 0, '', array(), $children, 9999, 0, 0 );

    // assemble menu items to the array
    $mitems     = array();
    $mitems[]   = mosHTML::makeOption( '0', 'Top' );

    foreach ( $list as $item ) {
        $mitems[] = mosHTML::makeOption( $item->id, '&nbsp;&nbsp;&nbsp;'. $item->treename );
    }

    $output = mosHTML::selectList( $mitems, $listName, 'class="inputbox"'.$size, 'value', 'text', $galleryid );

    echo $output;
}

    /**
     * Retrieves the thumbnail image. presented in the category overview
     * @param int Category id
     * @param int image height
     * @param int image width
     * @param string Class name to format thumb view in css files
     * @return string html tag, showing the thumbnail
     * @todo Make thumbnail selectable in backend. Probably requires an extra field in the database.
     */
     
    function getThumb($catid, $height = 0, $width = 0,$class = "") {
    global $database, $mosConfig_live_site;
    //Setting attributes for image tag 
    $imgatt="";
    if ($height>0)
        $imgatt.=" height=\"$height\" ";
    if ($width>0)
        $imgatt.=" width=\"$width\" ";
    if ($class != "")
        $imgatt.=" class=\"$class\" ";
    else
        $imgatt.=" class=\"RSgalthumb\" ";
    
    if ( galleryUtils::getFileCount($catid) == 0 )
        {
        $thumb_html = "<img $imgatt src=\"".$mosConfig_live_site."/components/com_rsgallery2/images/no_pics.gif\" alt=\"No pictures in gallery\" border=\"1\" />";
        }
    else
        {
        $sql = "SELECT thumb_id FROM #__rsgallery2_galleries WHERE id = '$catid'";
        $database->setQuery($sql);
        $thumb_id = $database->loadResult();
        if ( $thumb_id == 0 )
            {
            //Random thumbnail
            $sql = "SELECT name FROM #__rsgallery2_files WHERE gallery_id = '$catid' ORDER BY rand() LIMIT 1";
            $database->setQuery($sql);
            $thumb_name = $database->loadResult();
            }
        else
            {
            //Specific thumbnail
            $thumb_name = galleryUtils::getFileNameFromId($thumb_id);
            }
        $thumb_html = "<img $imgatt src=\"".imgUtils::getImgThumb($thumb_name)."\" alt=\"\" border=\"0\" />";
        }
    return $thumb_html;
    }
    
    /**
     * Returns number of files within a specific gallery
     * @param int Category id
     * @return int Number of files in category
     */
    function getFileCount($id)
        {
        global $database;
        $database->setQuery("SELECT count(*) FROM #__rsgallery2_files WHERE gallery_id = '$id'");
        $count = $database->loadResult();
        return $count;
        }
        
    /**
     * Retrieves category name, based on the category id
     * @param integer The ID of the currently selected category
     * @return string Category Name
     */
    function getCatnameFromId($id)
        {
        global $database;
        $database->setQuery("SELECT name FROM #__rsgallery2_galleries WHERE id = '$id'");
        $catname = $database->loadResult();
        return $catname;
        }
     
    /**
     * Retrieves category ID, based on the filename id
     * @param integer The ID of the currently selected file
     * @return string Category ID
     */
    function getCatIdFromFileId($id)
        {
        global $database;
        $database->setQuery("SELECT gallery_id FROM #__rsgallery2_files WHERE id = '$id'");
        $gallery_id = $database->loadResult();
        return $gallery_id;
        }
        
     /**
      * Retrieves filename, based on the filename id
      * @param integer The ID of the currently selected file
      * @return string Filename
      */    
     function getFileNameFromId($id)
        {
        global $database;
        $database->setQuery("SELECT name FROM #__rsgallery2_files WHERE id = '$id'");
        $filename = $database->loadResult();
        return $filename;
        }
    
    /**
      * Retrieves title, based on the filename id
      * @param integer The ID of the currently selected file
      * @return string title
      */    
     function getTitleFromId($id)
        {
        global $database;
        $database->setQuery("SELECT title FROM #__rsgallery2_files WHERE id = '$id'");
        $title = $database->loadResult();
        return $title;
        }
        
    /**
     * Creates new thumbnails with new settings
     * @param Category ID
     */
    function regenerateThumbs ($catid = NULL) {
    global $mosConfig_absolute_path, $database, $rsgConfig;
    $i = 0;
    $files  = mosReadDirectory( $mosConfig_absolute_path.$rsgConfig->get('imgPath_original') );
    //check if size is changed
    foreach ($files as $file)
        {
        if ( imgUtils::makeThumbImage( $mosConfig_absolute_path.$rsgConfig->get('imgPath_original').$file ) )
            continue;
        else
            $error[] = $file;
            $i++;
        }
    }
    
    function addHit($id)
        {
        global $database;
        //Get hits from DB
        $database->setQuery("SELECT hits FROM #__rsgallery2_files WHERE id = '$id'");
        $hits = $database->loadResult();
        $hits++;
        $database->setQuery("UPDATE #__rsgallery2_files SET hits = '$hits' WHERE id = '$id'");
        if ($database->query())
            {
            return(1);//OK
            }
        else
            {
            return(0);//Not OK
            }
        }
    
    function addCatHit($hid)
        {
        global $database;
        //Get hits from DB
        $database->setQuery("SELECT hits FROM #__rsgallery2_galleries WHERE id = '$hid'");
        $hits = $database->loadResult();
        $hits++;
        $database->setQuery("UPDATE #__rsgallery2_galleries SET hits = '$hits' WHERE id = '$hid'");
        if ($database->query())
            {
            return(1);//OK
            }
        else
            {
            return(0);//Not OK
            }
        }
        
    function showRating($id) {
        global $database,$mosConfig_live_site;
        $database->setQuery("SELECT * FROM #__rsgallery2_files WHERE id = '$id'");
        $values = array("No rating","Very bad","Bad","OK","Good","Very good");
        $rows = $database->loadObjectList();
        $images = "";
        foreach ($rows as $row)
            {
            $average = $row->rating/$row->votes;
            $average1 = round($average);
            for ($t = 1; $t <= $average1; $t++)
                {
                $images .= "<img src=\"$mosConfig_live_site/images/M_images/rating_star.png\">&nbsp;";
                }
            }
            return $images;
        }
        
    function newImages($xid) {
    global $database;
    $lastweek  = mktime (0, 0, 0, date("m"),    date("d") - 7, date("Y"));
    $lastweek = date("Y-m-d H:m:s",$lastweek);
    $database->setQuery("SELECT * FROM #__rsgallery2_files WHERE date >= '$lastweek' AND gallery_id = '$xid'");
    $rows = $database->loadObjectList();
    if (count($rows) > 0)
        {
        foreach ($rows as $row)
            {
            $gallery_id = $row->gallery_id;
            if ($gallery_id == $xid)
                {
                echo "<font class=\"newpics\">"._RSGALLERY_NEW."</font>";
                break;
                }
            }
        }
    else
        {
        echo "";
        }
    }
    
    /**
     * This function will retrieve the user Id's of the owner of this gallery.
     * @param integer id of category
     * @return the requested user id
     * @todo isn't there a joomla function for this?
     */
    function getUID($catid) {
        global $database;
        $database->setQuery("SELECT uid FROM #__rsgallery2_galleries WHERE id = '$catid'");
        $uid = $database->loadResult();
        return $uid;
        }
        
    /**
     * This function returns the number of created galleries by the logged in user
     * @param integer user ID
     * @return integer number of created categories
     */
     
    function userCategoryTotal($id) {
        global $database;
        $database->setQuery("SELECT count(*) FROM #__rsgallery2_galleries WHERE uid = '$id'");
        $cats = $database->loadResult();
        return $cats;
        }
    
    /**
     * This function returns the number of uploaded images  by the logged in user
     * @param integer user ID
     * @return integer number of uploaded images
     */
    function userImageTotal($id) {
        global $database;
        $database->setQuery("SELECT count(*) FROM #__rsgallery2_files WHERE userid = '$id'");
        $result = $database->loadResult();
        return $result;
        }
        
    /**
     * This function returns the number of uploaded images  by the logged in user
     * @param integer user ID
     * @return integer number of uploaded images
     */
    function latestCats() {
    global $my, $database;
    $database->setQuery("SELECT * FROM #__rsgallery2_galleries ORDER BY id DESC LIMIT 0,5");
    $rows = $database->loadObjectList();
    if (count($rows) > 0)
            {
            foreach ($rows as $row)
                {
                ?>
                <tr>
                    <td><?php echo $row->name;?></td>
                    <td><?php echo galleryUtils::genericGetUsername($row->uid);?></td>
                    <td><?php echo $row->id;?></td>
                </tr>
                <?php
                }
            }
        else
            {
            echo "<tr><td colspan=\"3\">No new entries</td></tr>";
            }
    }
    
    /**
     * This function will retrieve the user name based on the user id
     * @param integer user id
     * @return the username
     * @todo isn't there a joomla function for this?
     */
    function genericGetUsername($uid) {
        global $database, $name;
        $database->setQuery("SELECT username FROM #__users WHERE id = '$uid'");
        $name = $database->loadResult();
        
        return $name;
        }
        
    /**
     * This function will show the 5 last uploaded images
     */    
    function latestImages() {
    global $database, $rows;

    $lastweek  = mktime (0, 0, 0, date("m"),    date("d") - 7, date("Y"));
    $lastweek = date("Y-m-d H:m:s",$lastweek);
    $database->setQuery("SELECT * FROM #__rsgallery2_files WHERE date >= '$lastweek' ORDER BY id DESC LIMIT 0,5");
    $rows = $database->loadObjectList();
    if (count($rows) > 0)
        {
        foreach ($rows as $row)
            {
            ?>
            <tr>
                <td><?php echo $row->name;?></td>
                <td><?php echo galleryUtils::getCatnameFromId($row->gallery_id);?></td>
                <td><?php echo $row->date;?></td>
                <td><?php echo galleryUtils::genericGetUsername($row->userid);?></td>
            </tr>
            <?php
            }
        }
    else
        {
        echo "<tr><td colspan=\"4\">No new entries</td></tr>";
        }
    }
    
    /**
     * replaces spaces with underscores
     * replaces other weird characters with dashes
     * @param string input text
     * @return cleaned up text
    **/
    function replaceStrangeChar($text){
        $text = str_replace(" ", "_", $text);
        $text = preg_replace('/[^a-z0-9_\-\.]/i', '_', $text);
        return $text;
    }
    
    /**
     * Retrieves file ID based on the filename
     * @param string filename
     * @return integer File ID
     */
    function getFileIdFromName($filename) {
    global $database;
        $sql = "SELECT id FROM #__rsgallery2_files WHERE name = '$filename'";
        $database->setQuery($sql);
        $id = $database->loadResult();
        return $id;
    }
    
    /**
     * !!!!!!!!!!!!!!!!!!!! DUPLICATE FUNCTION !!!!!!!!!!!!!!!!!!!!!!
     * This is a duplicate from admin.rsgallery2.php
     * This is called both from the front- and backend. Better to put here I think
     * For now it remains in both admin.rsgallery2.php and config.rsgallery2.php
    */
    function reorderRSGallery ($tbl, $where = NULL ) {
       // reorders either the categories or images within a category
       // it is necessary to call this whenever a shuffle or deletion is performed
       global $database;
    
       $database->setQuery( "SELECT id, ordering FROM $tbl"
          . ($where ? "\nWHERE $where" : '')
          . "\nORDER BY ordering"
          );
       if (!($rows = $database->loadObjectList())) {
          return false;
       }
       // first pass, compact the ordering numbers
       $n=count( $rows );
    
       for ($i=0;  $i < $n; $i++) {
         $rows[$i]->ordering = $i+1;
         $database->setQuery( "UPDATE $tbl"
            . "\nSET ordering='".$rows[$i]->ordering."' WHERE id ='".$rows[$i]->id."'"
            );
         $database->query();
       }
    
       return true;
    }
}//end class

/*
 * Simple download class to download original images
 */
class galleryDownload {
	var $data = null;
	var $data_len = 0;
	var $data_mod = 0;
	var $data_type = 0;
	var $data_section = 0; //section download
	
	/**
	 * @var ObjectHandler
	 **/
	var $handler = array('auth' => null);
	var $use_resume = true;
	var $use_autoexit = false;
	var $use_auth = false;
	var $filename = null;
	var $mime = null;
	var $bufsize = 2048;
	var $seek_start = 0;
	var $seek_end = -1;
	
	/**
	 * Total bandwidth has been used for this download
	 * @var int
	 */
	var $bandwidth = 0;
	/**
	 * Speed limit
	 * @var float
	 */
	var $speed = 0;

	/**
	 * Check authentication and get seek position
	 * @return bool
	 */
	function initialize() {
		global $HTTP_SERVER_VARS;
		
		if ($this->use_auth) //use authentication
		{
			if (!$this->_auth()) //no authentication
			{
			header('WWW-Authenticate: Basic realm="Please enter your username and password"');
    		header('HTTP/1.0 401 Unauthorized');
    		header('status: 401 Unauthorized');
    		if ($this->use_autoexit) exit();
				return false;
			}
		}
		if ($this->mime == null) $this->mime = "application/octet-stream"; //default mime
		
		if (isset($_SERVER['HTTP_RANGE']) || isset($HTTP_SERVER_VARS['HTTP_RANGE'])) {
			if (isset($HTTP_SERVER_VARS['HTTP_RANGE'])) $seek_range = substr($HTTP_SERVER_VARS['HTTP_RANGE'] , strlen('bytes='));
			else $seek_range = substr($_SERVER['HTTP_RANGE'] , strlen('bytes='));
			
			$range = explode('-',$seek_range);
			
			if ($range[0] > 0) {
				$this->seek_start = intval($range[0]);
			}
			
			if ($range[1] > 0)
				$this->seek_end = intval($range[1]);
			else 
				$this->seek_end = -1;
			
			if (!$this->use_resume) {
				$this->seek_start = 0;
			}
			else {
				$this->data_section = 1;
			}
		}
		else {
			$this->seek_start = 0;
			$this->seek_end = -1;
		}
		
		return true;
	}
	
	/**
	 * Write downloadlink for image
	 * @param int image ID
	 * @type string button of HTML link (button/link)
	 * @return HTML for downloadlink
	 */
	 function writeDownloadLink($id, $type = 'button', $text = 'Download image') {
	 	global $mosConfig_live_site, $mosConfig_absolute_path;
	 	if ($type == 'button')
	 		{
	 		?>
	 		<a href="index.php?option=com_rsgallery2&page=downloadfile&id=<?php echo $id;?>">
	 		<img height="20" width="20" src="<?php echo $mosConfig_live_site;?>/administrator/images/download_f2.png" alt="<?php echo $text;?>">
	 		<span style="font-size:smaller;">Download</span>
	 		</a>
	 		<?php
	 		}
	 	else
	 		{
	 		?>
	 		<a href="index.php?option=com_rsgallery2&page=downloadfile&id=<?php echo $id;?>"><?php echo $text;?></a>
	 		<?php
	 		}
	 }
	/**
	 * Send download information header
	 **/
	function header($size,$seek_start=null,$seek_end=null) {
		header('Content-type: ' . $this->mime);
		header('Content-Disposition: attachment; filename="' . $this->filename . '"');
		header('Last-Modified: ' . date('D, d M Y H:i:s \G\M\T' , $this->data_mod));
		
		if ($this->data_section && $this->use_resume)
		{
			header("HTTP/1.0 206 Partial Content");
			header("Status: 206 Partial Content");
			header('Accept-Ranges: bytes');
			header("Content-Range: bytes $seek_start-$seek_end/$size");
			header("Content-Length: " . ($seek_end - $seek_start + 1));
		}
		else
		{
			header("Content-Length: $size");
		}
	}
	
	function download_ex($size)
	{
		if (!$this->initialize()) return false;
		ignore_user_abort(true);
		//Use seek end here
		if ($this->seek_start > ($size - 1)) $this->seek_start = 0;
		if ($this->seek_end <= 0) $this->seek_end = $size - 1;
		$this->header($size,$seek,$this->seek_end);
		$this->data_mod = time();
		return true;
	}
	
	/**
	 * Start download
	 * @return bool
	 **/
	function download() {
		if (!$this->initialize()) return false;
		
		$seek = $this->seek_start;
		$speed = $this->speed;
		$bufsize = $this->bufsize;
		$packet = 1;
		
		//do some clean up
		@ob_end_clean();
		$old_status = ignore_user_abort(true);
		@set_time_limit(0);
		$this->bandwidth = 0;
		
		$size = $this->data_len;
		
		if ($this->data_type == 0) //download from a file
		{
			
			$size = filesize($this->data);
			if ($seek > ($size - 1)) $seek = 0;
			if ($this->filename == null) $this->filename = basename($this->data);
			
			$res = fopen($this->data,'rb');
			if ($seek) fseek($res , $seek);
			if ($this->seek_end < $seek) $this->seek_end = $size - 1;
			
			$this->header($size,$seek,$this->seek_end); //always use the last seek
			$size = $this->seek_end - $seek + 1;
			
			while (!(connection_aborted() || connection_status() == 1) && $size > 0)
			{
				if ($size < $bufsize)
				{
					echo fread($res , $size);
					$this->bandwidth += $size;
				}
				else
				{
					echo fread($res , $bufsize);
					$this->bandwidth += $bufsize;
				}
				
				$size -= $bufsize;
				flush();
				
				if ($speed > 0 && ($this->bandwidth > $speed*$packet*1024))
				{
					sleep(1);
					$packet++;
				}
			}
			fclose($res);
			
		}
		
		elseif ($this->data_type == 1) //download from a string
		{
			if ($seek > ($size - 1)) $seek = 0;
			if ($this->seek_end < $seek) $this->seek_end = $this->data_len - 1;
			$this->data = substr($this->data , $seek , $this->seek_end - $seek + 1);
			if ($this->filename == null) $this->filename = time();
			$size = strlen($this->data);
			$this->header($this->data_len,$seek,$this->seek_end);
			while (!connection_aborted() && $size > 0) {
				if ($size < $bufsize)
				{
					$this->bandwidth += $size;
				}
				else
				{
					$this->bandwidth += $bufsize;
				}
				
				echo substr($this->data , 0 , $bufsize);
				$this->data = substr($this->data , $bufsize);
				
				$size -= $bufsize;
				flush();
				
				if ($speed > 0 && ($this->bandwidth > $speed*$packet*1024))
				{
					sleep(1);
					$packet++;
				}
			}
		} else if ($this->data_type == 2) {
			//just send a redirect header
			header('location: ' . $this->data);
		}
		
		if ($this->use_autoexit) exit();
		
		//restore old status
		ignore_user_abort($old_status);
		set_time_limit(ini_get("max_execution_time"));
		
		return true;
	}
	
	function set_byfile($dir) {
		if (is_readable($dir) && is_file($dir)) {
			$this->data_len = 0;
			$this->data = $dir;
			$this->data_type = 0;
			$this->data_mod = filemtime($dir);
			return true;
		} else return false;
	}
	
	function set_bydata($data) {
		if ($data == '') return false;
		$this->data = $data;
		$this->data_len = strlen($data);
		$this->data_type = 1;
		$this->data_mod = time();
		return true;
	}
	
	function set_byurl($data) {
		$this->data = $data;
		$this->data_len = 0;
		$this->data_type = 2;
		return true;
	}
	
	function set_lastmodtime($time) {
		$time = intval($time);
		if ($time <= 0)
			$time = time();
		$this->data_mod = $time;
	}
	
	/**
	 * Check authentication
	 * @return bool
	 **/
	function _auth() {
		if (!isset($_SERVER['PHP_AUTH_USER'])) return false;
		if (isset($this->handler['auth']) && function_exists($this->handler['auth']))
		{
			return $this->handler['auth']('auth' , $_SERVER['PHP_AUTH_USER'],$_SERVER['PHP_AUTH_PW']);
		}
		else
			return true; //you must use a handler
	}
	
	
}//end class

/**
 * The functions below do not seem to be used.
 * If they are used, move them to the galleryUtils class above
 * and remove the 'X' in front of the function.
 * Also call the function like this: galleryUtils::function($params)
 */

function XgetCurrentDate()
    {
    $now = getdate(); 
    $datetime = $now['year']."-".$now['mon']."-".$now['mday']." ".$now['hours'].":".$now['minutes'].":".$now['seconds']; 
    echo $datetime;
    }
    
function XregenerateAllThumbs($catid = NULL)
    {
    // re-do all thumbnail pics for selected category(s) or all pics in directory
    global $database, $mosConfig_absolute_path, $imagepath, $conversiontype, $size, $jpegQuality,$IM_path;

    // dmcd to do:

    // 1. put back in GD1 thumbnail call
    // 2. check for database query error
    // 3. if there are a lot of pics, this can take a while, so may need to
    //    reset php max execution timeout so it does not terminate prematurely

    // if manual thumb creation has been chosen, then no resizing will occur
    if($conversiontype == 0) return;

    // $catid == 0  all categories
    // $catid == NULL all pic files found in gallery subdirectory
    // $catid == 1..  all pic files for that particular category

    if(isset($catid) && $catid == 0)
        $database->setQuery("SELECT name FROM #__rsgallery2_files");
    elseif($catid != NULL)
        $database->setQuery("SELECT name FROM #__rsgallery2_files WHERE gallery_id='$catid'");

    if($catid != NULL){
        $files = loadObjectList('name');

    // if there is no thumbs subdirectory, then no thumbs can be generated
        if(!(file_exists($mosConfig_absolute_path.$imagepath."thumbs"))) return;
        $pics = mosReadDirectory($mosConfig_absolute_path.$imagepath);
        $maxsize    = $size;
        $quality    = $jpegQuality;
        foreach($pics as $pic)
            {
            // check to see if we want to do this pic
            // No need to check catid again, since it must be non-null for us to get here!
            if(!array_key_exists($files, $pic)) continue;

            // go regenerate the thumbs
            $file_in = $mosConfig_absolute_path.$imagepath.$pic;
            $file_out = $mosConfig_absolute_path.$imagepath."thumbs/".$pic;
            if(is_dir($file_in)) continue;
            // delete the existing thumb if present
            if(file_exists($file_out)) unlink($file_out);
            switch ($conversiontype)
                {
                //ImageMagick
                case 1:
                    $cmd = $IM_path."convert -resize $size $file_in $file_out";
                    @exec($cmd);
                    break;
                //NETPBM
                case 2:
                    CreateThumbNETPBM($file_in,$file_out,$maxsize,$pic,$quality);
                    break;
                //GD1
                case 3:
                    CreateThumbGD2($file_in, $file_out, $quality, $maxsize, 'gd1');
                    break;
                //GD2
                case 4:
                    CreateThumbGD2($file_in, $file_out, $quality, $maxsize);
                    break;
                }
            }
        }
    }

function XgetParentCat($id)
    {
    global $database;
    $database->setQuery("SELECT parent FROM #__rsgallery2_galleries WHERE id = '$id'");
    $p_id = $database->loadResult();
    if ($p_id == 0)
        {
        return 0;
        }
    else
        {
        $database->setQuery("SELECT name FROM #__rsgallery2_galleries WHERE id = '$p_id'");
        $catname = $database->loadResult();
        return $catname."/";
        }
    }

function XshowSubcats($c_id)
    {
    global $database, $mosConfig_live_site;

    $database->setQuery("SELECT * FROM #__rsgallery2_galleries WHERE parent = '$c_id' and published=1");
    $rows = $database->loadObjectList();


    $i = 0;
    if ($rows)
        {
        ?>
        <table cellspacing=0 cellpadding=0 border="0" width="100%">
            <tr>
                <td width="25%">&nbsp;</td>
                <td width="50%" colspan="2"><?php echo _RSGALLERY_SUBCAT; ?></td>
                <td width="25%"><br></td>
            </tr>
    
        <?php
        foreach($rows as $row)
            {
            ?>
            <tr>
                <td>&nbsp;</td>
                <td colspan="2">
                <a href="index.php?option=com_rsgallery2&amp;catid=<?php echo $row->id;?>"><img src="<?php echo $mosConfig_live_site?>/components/com_rsgallery2/images/folder.gif" border="0">&nbsp;&nbsp;&nbsp;<?php echo $row->name."&nbsp;&nbsp;(".getNumber($row->id)."&nbsp;pics)";?></a></td>
                <td>&nbsp;</td>
            </tr>
            <?php
            $i++;
            }
        ?>
        </table>
        <?php

        }
    echo "<br />";
    }

function XcheckParent($id)
    {
    global $database;
    $database->setQuery("SELECT parent FROM #__rsgallery2_galleries WHERE id = '$id'");
    $p_id = $database->loadResult();
    if ($p_id == 0)
        {
        return 0;
        }
    else
        {
        return 1;
        }
    }

/**
 * This function will retrieve the user Id's and names of the allowed viewers of this gallery 
 * when choosing Custom Access Control for this gallery and populate a listbox with them.
 * @param integer id of category
 */
function XgetAllowed($catid)
    {
    global $database, $catid;
    $database->setQuery("SELECT allowed FROM #__rsgallery2_galleries WHERE id = '$catid'");
    //Create usable array to extract user ID-s.
    $allowed = unserialize($database->loadResult());
    //Generate listbox with usernames
    foreach ($allowed as $item)
        {
        echo "<option value=\"$item\">".genericGetUsername($item)."</option>";
        }
    }
/**
 * This function will retrieve the user Id's and names of all registered users 
 * and populates a listbox with them.
 * @return all users in listbox
 */
function XgetUsers()
    {
    global $database;
    $database->setQuery("SELECT * FROM #__users ORDER BY username ASC");
    $rows = $database->loadObjectList();

    foreach ($rows as $row)
        {
        echo "<option value=\"$row->id\">$row->username</option>";
        }
    }

/**
* Checks if user is registered or higher
* @param string User Id
* @return string No or Yes (0 or 1)
*/
function XcheckAccess($id)
    {
    global $acl;
    $aro_group  = $acl->getAroGroup( $id );
    $group_id = $aro_group->group_id;
    //Get children from grouptype 'registered'
    $group_children = $acl->get_group_children(18, 'ARO', 'RECURSE');
    $is_child = $acl->is_group_child_of( $aro_group->name, 'Registered', 'ARO' );
    if ( is_array( $group_children ) && count( $group_children ) > 0)
        {
        //there are child groups. See if user is in any ot them
        if ($group_id == 18 || $is_child == 1)
            {
            //user is registered or above
            return 1;
            }
        else
            {
            return 0;
            }
        }
    }

/**
 * Function checks if an image file is in the allowed filetypes list.
 * @return true on succesfull match
 * @todo Add mime type check on every file
 */
function XisAllowedFileType($file, $allowed_filetypes)
    {
    //Lower case for case insensitive checking
    $file = strtolower($file);
    //Check extension
    $parts = explode(".", $file);
    $parts = array_reverse($parts);
    $ext = $parts[0];
    $allowed = explode(",", $allowed_filetypes);
    if (in_array($ext, $allowed))
        {
        return true;
        }
    }
?>