<?php

/**
* Galleries option for RSGallery2 - HTML display code
* @version $Id$
* @package RSGallery2
* @copyright (C) 2003 - 2006 RSGallery2
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* RSGallery is Free Software
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class html_rsg2_galleries{
    /**
        show list of galleries
    **/
    function show( &$rows, &$lists, &$search, &$pageNav ){
        global $my, $rsgOption, $option;

        mosCommonHTML::loadOverlib();
        ?>
        <form action="index2.php" method="post" name="adminForm">
        <table class="adminheading">
        <tr>
            <th>
            Gallery Manager
            </th>
            <td nowrap="true">
            Max Levels
            </td>
            <td>
            <?php echo $lists['levellist'];?>
            </td>
            <td>
            Filter:
            </td>
            <td>
            <input type="text" name="search" value="<?php echo $search;?>" class="text_area" onChange="document.adminForm.submit();" />
            </td>
        </tr>
        </table>

        <table class="adminlist">
        <tr>
            <th width="5">
            #
            </th>
            <th width="20">
            <input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $rows ); ?>);" />
            </th>
            <th class="Name">
            Name
            </th>
            <th width="5%">
            Published
            </th>
            <th colspan="2" width="5%">
            Reorder
            </th>
            <th width="5%">
            Hits
            </th>
        </tr>
        <?php
        $k = 0;
        for ($i=0, $n=count( $rows ); $i < $n; $i++) {
            $row = &$rows[$i];

            $link   = "index2.php?option=$option&rsgOption=$rsgOption&task=editA&hidemainmenu=1&id=". $row->id;

            $task   = $row->published ? 'unpublish' : 'publish';
            $img    = $row->published ? 'publish_g.png' : 'publish_x.png';
            $alt    = $row->published ? 'Published' : 'Unpublished';

            $checked    = mosCommonHTML::CheckedOutProcessing( $row, $i );
            ?>
            <tr class="<?php echo "row$k"; ?>">
                <td>
                <?php echo $pageNav->rowNumber( $i ); ?>
                </td>
                <td>
                <?php echo $checked; ?>
                </td>
                <td>
                <?php
                if ( $row->checked_out && ( $row->checked_out != $my->id ) ) {
                    echo $row->name;
                } else {
                    ?>
                    <a href="<?php echo $link; ?>" name="Edit Gallery">
                    <?php echo $row->treename;; ?>
                    </a>
                    <?php
                }
                ?>
                </td>
                <td align="center">
                <a href="javascript: void(0);" onclick="return listItemTask('cb<?php echo $i;?>','<?php echo $task;?>')">
                <img src="images/<?php echo $img;?>" width="12" height="12" border="0" alt="<?php echo $alt; ?>" />
                </a>
                </td>
                <td>
                <?php echo $pageNav->orderUpIcon( $i ); ?>
                </td>
                <td>
                <?php echo $pageNav->orderDownIcon( $i, $n ); ?>
                </td>
                <td align="center">
                <?php echo $row->hits; ?>
                </td>
            </tr>
            <?php
            $k = 1 - $k;
        }
        ?>
        </table>
        <?php echo $pageNav->getListFooter(); ?>
        <input type="hidden" name="option" value="<?php echo $option;?>" />
        <input type="hidden" name="rsgOption" value="<?php echo $rsgOption;?>" />
        <input type="hidden" name="task" value="" />
        <input type="hidden" name="boxchecked" value="0" />
        <input type="hidden" name="hidemainmenu" value="0">
        </form>
        <?php
    }
    
    /**
    * Writes the edit form for new and existing record
    *
    * A new record is defined when <var>$row</var> is passed with the <var>id</var>
    * property set to 0.
    * @param rsgGallery The gallery object
    * @param array An array of select lists
    * @param object Parameters
    * @param string The option
    */
    function edit( &$row, &$lists, &$params, $option ) {
        global $rsgOption, $my;
        mosMakeHtmlSafe( $row, ENT_QUOTES, 'description' );
        
        mosCommonHTML::loadOverlib();
        ?>
        <script language="javascript" type="text/javascript">
        function submitbutton(pressbutton) {
            var form = document.adminForm;
            if (pressbutton == 'cancel') {
                submitform( pressbutton );
                return;
            }

            // do field validation
            if (form.name.value == ""){
                alert( "Gallery must have a name" );
            } else {
                <?php getEditorContents( 'editor1', 'description' ) ; ?>
                submitform( pressbutton );
            }
        }
        </script>
        <form action="index2.php" method="post" name="adminForm" id="adminForm">
        <table class="adminheading">
        <tr>
            <th>
            Gallery:
            <small>
            <?php echo $row->id ? 'Edit' : 'New';?>
            </small>
            </th>
        </tr>
        </table>

        <table width="100%">
        <tr>
            <td width="60%" valign="top">
                <table class="adminform">
                <tr>
                    <th colspan="2">
                    Details
                    </th>
                </tr>
                <tr>
                    <td width="20%" align="right">
                    Name:
                    </td>
                    <td width="80%">
                    <input class="text_area" type="text" name="name" size="50" maxlength="250" value="<?php echo $row->name;?>" />
                    </td>
                </tr>
                <tr>
                    <td valign="top" align="right">
                    Description:
                    </td>
                    <td>
                    <?php
                    // parameters : areaname, content, hidden field, width, height, rows, cols
                    editorArea( 'editor1',  $row->description , 'description', '100%;', '300', '10', '20' ) ; ?>
                    </td>
                </tr>
                <tr>
                    <td align="right">
                    Parent Item:
                    </td>
                    <td>
                    <?php echo $lists['parent']; ?>
                    </td>
                </tr>
                <tr>
                    <td valign="top" align="right">
                    Category thumbnail:
                    </td>
                    <td>
                    <?php echo imgUtils::showThumbNames($row->id, $row->thumb_id) ?>
                    </td>
                </tr>
                <tr>
                    <td valign="top" align="right">
                    Ordering:
                    </td>
                    <td>
                    <?php echo $lists['ordering']; ?>
                    </td>
                </tr>
                <tr>
                    <td valign="top" align="right">
                    Published:
                    </td>
                    <td>
                    <?php echo $lists['published']; ?>
                    </td>
                </tr>
                </table>
            </td>
            <td width="40%" valign="top">
                <table class="adminform">
                <tr>
                    <th colspan="1">
                    Parameters
                    </th>
                </tr>
                <tr>
                    <td>
                    <?php echo $params->render();?>
                    </td>
                </tr>
                </table>
            </td>
        </tr>
        </table>
        <input type="hidden" name="uid" value="<?php echo $my->id; ?>" />
        <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
        <input type="hidden" name="rsgOption" value="<?php echo $rsgOption;?>" />
        <input type="hidden" name="option" value="<?php echo $option;?>" />
        <input type="hidden" name="task" value="" />
        </form>
        <?php
    }
}
?>